Loading...
Searching...
No Matches
juce::OpenGLRenderer Class Referenceabstract

## Detailed Description

A base class that should be implemented by classes which want to render openGL on a background thread.

See also
  OpenGLContext

The documentation for this class was generated from the following file:

- juce_opengl/opengl/juce_OpenGLRenderer.h

Inheritance diagram for juce::OpenGLRenderer:

## Public Member Functions

| OpenGLRenderer ()=default
virtual | ~OpenGLRenderer ()=default
virtual void | newOpenGLContextCreated ()=0
| Called when a new GL context has been created.
virtual void | renderOpenGL ()=0
| Called when you should render the next openGL frame.
virtual void | openGLContextClosing ()=0
| Called when the current openGL context is about to close.

## Constructors and Destructors

## OpenGLRenderer()

juce::OpenGLRenderer::OpenGLRenderer | ( |  | ) |

default

## ~OpenGLRenderer()

virtual juce::OpenGLRenderer::~OpenGLRenderer | ( |  | ) |

virtual default

## Member Functions

## newOpenGLContextCreated()

virtual void juce::OpenGLRenderer::newOpenGLContextCreated | ( |  | ) |

pure virtual

Called when a new GL context has been created.

You can use this as an opportunity to create your textures, shaders, etc. When the method is invoked, the new GL context will be active. Note that this callback will be made on a background thread, so make sure that your implementation is thread-safe.

## renderOpenGL()

virtual void juce::OpenGLRenderer::renderOpenGL | ( |  | ) |

pure virtual

Called when you should render the next openGL frame.

Note that this callback will be made on a background thread.

If the context is attached to a component in order to do component rendering, then the MessageManager will be locked when this callback is made.

If no component rendering is being done, then the MessageManager will not be locked, and you'll need to make sure your code is thread-safe in any interactions it has with your GUI classes.

For information about how to trigger a render callback, see OpenGLContext::triggerRepaint() and OpenGLContext::setContinuousRepainting().

IMPORTANT: Never take a MessageManagerLock inside this function! On macOS, the OpenGL context will be locked for the duration of this call. The main thread may also attempt to interact with the OpenGL context at any time, which will also require locking the OpenGL context. As a result, taking a MessageManagerLock inside renderOpenGL() may cause a hierarchical deadlock.

## openGLContextClosing()

virtual void juce::OpenGLRenderer::openGLContextClosing | ( |  | ) |

pure virtual

Called when the current openGL context is about to close.

You can use this opportunity to release any GL resources that you may have created.

Note that this callback will be made on a background thread, so make sure that your implementation is thread-safe.

(Also note that on Android, this callback won't happen, because there's currently no way to implement it.)

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited